/*
 * JPA DAO Template
 *
 *
 * Takatuka - Template fuer JPA DAO
 *
 */

package de.ivu.elect.business.staat.boundary;

import javax.persistence.NoResultException;
import javax.persistence.NonUniqueResultException;
import javax.persistence.EntityNotFoundException;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import de.ivu.elect.business.staat.entity.StaatenGruppe;
import de.ivu.elect.business.staat.entity.StaatenGruppeUK;

public abstract class AbstractStaatenGruppeDAO extends de.ivu.elect.jee.entity.AbstractDAO<StaatenGruppe,
        de.ivu.elect.business.staat.entity.StaatenGruppePK
    , StaatenGruppeUK> {

  private static final long serialVersionUID = 1L;

  private static final Logger LOG = LoggerFactory.getLogger(AbstractStaatenGruppeDAO.class);

  public AbstractStaatenGruppeDAO() {
    super();
  }

  public boolean isEntityWithPKPresent(
            de.ivu.elect.business.staat.entity.StaatenGruppePK
     pk) {
    if (pk != null && pk.getId() != null) {
      return findByPrimaryKey(pk) != null;
    }

    return false;
  }

  @Override
  public StaatenGruppe findByPrimaryKey(
        de.ivu.elect.business.staat.entity.StaatenGruppePK
      pk) {
    if (pk != null && pk.getId() != null) {
      return findByPrimaryKey(pk.getId());
    }

    throw new IllegalArgumentException("PK oder PK.getId() ist null! [pk = " + pk + "]");
  }


  @Override
  protected StaatenGruppe findByPrimaryKey(Long id) {
    if (id == null) {
      throw new IllegalArgumentException("ID ist null! [id = " + id + "]");
    }
  return getEntityManager().find(StaatenGruppe.class, id, CACHE_PROPERTIES);
  }



     /**
      * Name: WahlAndStaatenGruppeTypNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT obj FROM StaatenGruppe obj WHERE obj.wahl = ?1 AND obj.staatenGruppeTyp IN (?2)<br>
      * SQL: <br>
      */
     public java.util.List<StaatenGruppe> findByWahlAndStaatenGruppeTyp( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahl wahl,  @javax.annotation.Nonnull java.util.Collection<de.ivu.elect.business.staat.entity.StaatenGruppeTyp> staatenGruppeTypen) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.wahl.entity.Wahl wahlCheckedAndAttached =  checkAndAttach(wahl, de.ivu.elect.business.wahl.entity.Wahl.class, "wahl"); ;
		  			  java.util.Collection<de.ivu.elect.business.staat.entity.StaatenGruppeTyp> staatenGruppeTypenCheckedAndAttached =  staatenGruppeTypen ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("STAATEN_GRUPPE.WahlAndStaatenGruppeTyp")
                              .setParameter(1, wahlCheckedAndAttached)
                                        .setParameter(2, staatenGruppeTypenCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByWahlAndStaatenGruppeTyp - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("StaatenGruppe, findByWahlAndStaatenGruppeTyp - NonUniqueResultException, Parameter: "
           + ", wahl:'"+wahl+"'"
           + ", staatenGruppeTypen:'"+staatenGruppeTypen+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByWahlAndStaatenGruppeTyp(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: WahlNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT obj FROM StaatenGruppe obj WHERE obj.wahl = ?1<br>
      * SQL: <br>
      */
     public java.util.List<StaatenGruppe> findByWahl( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahl wahl) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.wahl.entity.Wahl wahlCheckedAndAttached =  checkAndAttach(wahl, de.ivu.elect.business.wahl.entity.Wahl.class, "wahl"); ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("STAATEN_GRUPPE.Wahl")
                              .setParameter(1, wahlCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByWahl - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("StaatenGruppe, findByWahl - NonUniqueResultException, Parameter: "
           + ", wahl:'"+wahl+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByWahl(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: WahlterminAndStaatenGruppeTypNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT obj FROM StaatenGruppe obj WHERE obj.wahltermin = ?1 AND obj.staatenGruppeTyp IN (?2)<br>
      * SQL: <br>
      */
     public java.util.List<StaatenGruppe> findByWahlterminAndStaatenGruppeTyp( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahltermin wahltermin,  @javax.annotation.Nonnull java.util.Collection<de.ivu.elect.business.staat.entity.StaatenGruppeTyp> staatenGruppeTypen) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.wahl.entity.Wahltermin wahlterminCheckedAndAttached =  checkAndAttach(wahltermin, de.ivu.elect.business.wahl.entity.Wahltermin.class, "wahltermin"); ;
		  			  java.util.Collection<de.ivu.elect.business.staat.entity.StaatenGruppeTyp> staatenGruppeTypenCheckedAndAttached =  staatenGruppeTypen ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("STAATEN_GRUPPE.WahlterminAndStaatenGruppeTyp")
                              .setParameter(1, wahlterminCheckedAndAttached)
                                        .setParameter(2, staatenGruppeTypenCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByWahlterminAndStaatenGruppeTyp - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("StaatenGruppe, findByWahlterminAndStaatenGruppeTyp - NonUniqueResultException, Parameter: "
           + ", wahltermin:'"+wahltermin+"'"
           + ", staatenGruppeTypen:'"+staatenGruppeTypen+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByWahlterminAndStaatenGruppeTyp(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: WahlterminNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT obj FROM StaatenGruppe obj WHERE obj.wahltermin = ?1<br>
      * SQL: <br>
      */
     public java.util.List<StaatenGruppe> findByWahltermin( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahltermin wahltermin) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.wahl.entity.Wahltermin wahlterminCheckedAndAttached =  checkAndAttach(wahltermin, de.ivu.elect.business.wahl.entity.Wahltermin.class, "wahltermin"); ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("STAATEN_GRUPPE.Wahltermin")
                              .setParameter(1, wahlterminCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByWahltermin - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("StaatenGruppe, findByWahltermin - NonUniqueResultException, Parameter: "
           + ", wahltermin:'"+wahltermin+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByWahltermin(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }



  @Override
  public boolean isEntityWithUKPresent(de.ivu.elect.business.staat.entity.StaatenGruppeUK uk) {
    try {
      return findByUK(uk) != null;
    } catch (javax.persistence.NoResultException nre) {
      return false;
    }
  }

  @Override
  public boolean isEntityWithUKHasPK(de.ivu.elect.business.staat.entity.StaatenGruppeUK uk,
        de.ivu.elect.business.staat.entity.StaatenGruppePK
      pk

  ) {
    try {
      return findByUK(uk).getPk().equals(pk);
    } catch (NoResultException ignored) {
      // Do nothing - be happy.
    }
    return true;
  }

   public de.ivu.elect.business.staat.entity.StaatenGruppe findByUK(de.ivu.elect.business.staat.entity.StaatenGruppeUK uk){

    try {
     return (de.ivu.elect.business.staat.entity.StaatenGruppe) getEntityManager().createNamedQuery("STAATEN_GRUPPE.UK")
                  .setParameter(1, uk
                .getBezeichnung ()  
              )
          .getSingleResult()
     ;
     } catch (NonUniqueResultException nure) {
        LOG.warn("StaatenGruppe, findByUK - NonUniqueResultException, UK: " + uk);
        throw nure;
     }
  }
    
}